#ifndef _JZ_P32MX_DEVCFG_H_
#define _JZ_P32MX_DEVCFG_H_
#include <stdint.h>

  #define DEVCFG3          (*(volatile unsigned *)0xBFC00BF0)
  #define DEVCFG2          (*(volatile unsigned *)0xBFC00BF4)
  #define DEVCFG1          (*(volatile unsigned *)0xBFC00BF8)
  #define DEVCFG0          (*(volatile unsigned *)0xBFC00BFC)

    #define DEVCFG3_USERID                 0x00
    #define DEVCFG3_PMDL1WAY               0x1C
    #define DEVCFG3_IOL1WAY                0x1D
    #define DEVCFG3_FUSBIDIO               0x1E
    #define DEVCFG3_FVBUSONIO              0x1F
    #define DEVCFG2_FPLLIDIV               0x00
    #define DEVCFG2_FPLLMUL                0x04
    #define DEVCFG2_UPLLIDIV               0x08
    #define DEVCFG2_UPLLEN                 0x0F
    #define DEVCFG2_FPLLODIV               0x10
    #define DEVCFG1_FNOSC                  0x00
    #define DEVCFG1_FSOSCEN                0x05
    #define DEVCFG1_IESO                   0x07
    #define DEVCFG1_POSCMOD                0x08
    #define DEVCFG1_OSCIOFNC               0x0A
    #define DEVCFG1_FPBDIV                 0x0C
    #define DEVCFG1_FCKSM                  0x0E
    #define DEVCFG1_WDTPS                  0x10
    #define DEVCFG1_WINDIS                 0x16
    #define DEVCFG1_FWDTEN                 0x17
    #define DEVCFG1_FWDTWINSZ              0x18
    #define DEVCFG0_DEBUG                  0x00
    #define DEVCFG0_JTAGEN                 0x02
    #define DEVCFG0_ICESEL                 0x03
    #define DEVCFG0_PWP                    0x0A
    #define DEVCFG0_BWP                    0x18
    #define DEVCFG0_CP                     0x1C
    #define DEVCFG0_FDEBUG                 0x00

  #define CFGCON           (*(volatile unsigned *)0xBF80F200)
  #define DDPCON           (*(volatile unsigned *)0xBF80F200)
  #define DEVID            (*(volatile unsigned *)0xBF80F220)

    #define CFGCON_TDOEN                   0x00
    #define CFGCON_TROEN                   0x02
    #define CFGCON_JTAGEN                  0x03
    #define CFGCON_PMDLOCK                 0x0C
    #define CFGCON_IOLOCK                  0x0D
    #define DDPCON_TDOEN                   0x00
    #define DDPCON_TROEN                   0x02
    #define DDPCON_JTAGEN                  0x03
    #define DDPCON_PMDLOCK                 0x0C
    #define DDPCON_IOLOCK                  0x0D
    #define DEVID_DEVID                    0x00
    #define DEVID_VER                      0x1C

  #define SYSKEY           (*(volatile unsigned *)0xBF80F230)
  #define SYSKEY_CLR       (*(volatile unsigned *)0xBF80F234)
  #define SYSKEY_SET       (*(volatile unsigned *)0xBF80F238)
  #define SYSKEY_INV       (*(volatile unsigned *)0xBF80F23C)

  struct devcfg3 {
    unsigned USERID:16;
    unsigned reserved1:12;
    unsigned PMDL1WAY:1;
    unsigned IOL1WAY:1;
    unsigned FUSBIDIO:1;
    unsigned FVBUSONIO:1;
  };
  struct devcfg2 {
    unsigned FPLLIDIV:3;
    unsigned reserved1:1;
    unsigned FPLLMUL:3;
    unsigned reserved2:1;
    unsigned UPLLIDIV:3;
    unsigned reserved3:4;
    unsigned UPLLEN:1;
    unsigned FPLLODIV:3;
  };
  struct devcfg1 {
    unsigned FNOSC:3;
    unsigned reserved1:2;
    unsigned FSOSCEN:1;
    unsigned reserved2:1;
    unsigned IESO:1;
    unsigned POSCMOD:2;
    unsigned OSCIOFNC:1;
    unsigned reserved3:1;
    unsigned FPBDIV:2;
    unsigned FCKSM:2;
    unsigned WDTPS:5;
    unsigned reserved4:1;
    unsigned WINDIS:1;
    unsigned FWDTEN:1;
    unsigned FWDTWINSZ:2;
  };
  struct devcfg0 {
    unsigned DEBUG:2;
    unsigned JTAGEN:1;
    unsigned ICESEL:2;
    unsigned reserved1:5;
    unsigned PWP:6;
    unsigned reserved2:8;
    unsigned BWP:1;
    unsigned reserved3:3;
    unsigned CP:1;
  };
#endif /* _JZ_P32MX_DEVCFG_H_ */
