#ifndef _JZ_P32MX_DMAC_H_
#define _JZ_P32MX_DMAC_H_
#include <stdint.h>

#ifdef _USE_BASE_ADDR
extern uint32_t _dmac_base_addr;  // = 0xBF883000;
#define _DMAC_ADDR	 (_dmac_base_addr)
#define _DMAC_CH_ADDR(x) (_dmac_base_addr + 0x60 + (x)*0xc0)

  #define DMACON           (*(volatile uint32_t *)(0x00 + _DMAC_ADDR)
  #define DMACON_CLR       (*(volatile uint32_t *)(0x04 + _DMAC_ADDR)
  #define DMACON_SET       (*(volatile uint32_t *)(0x08 + _DMAC_ADDR)
  #define DMACON_INV       (*(volatile uint32_t *)(0x0C + _DMAC_ADDR)
  #define DMASTAT          (*(volatile uint32_t *)(0x10 + _DMAC_ADDR)
  #define DMASTAT_CLR      (*(volatile uint32_t *)(0x14 + _DMAC_ADDR)
  #define DMASTAT_SET      (*(volatile uint32_t *)(0x18 + _DMAC_ADDR)
  #define DMASTAT_INV      (*(volatile uint32_t *)(0x1C + _DMAC_ADDR)
  #define DMAADDR          (*(volatile uint32_t *)(0x20 + _DMAC_ADDR)
  #define DMAADDR_CLR      (*(volatile uint32_t *)(0x24 + _DMAC_ADDR)
  #define DMAADDR_SET      (*(volatile uint32_t *)(0x28 + _DMAC_ADDR)
  #define DMAADDR_INV      (*(volatile uint32_t *)(0x2C + _DMAC_ADDR)
  #define DCRCCON          (*(volatile uint32_t *)(0x30 + _DMAC_ADDR)
  #define DCRCCON_CLR      (*(volatile uint32_t *)(0x34 + _DMAC_ADDR)
  #define DCRCCON_SET      (*(volatile uint32_t *)(0x38 + _DMAC_ADDR)
  #define DCRCCON_INV      (*(volatile uint32_t *)(0x3C + _DMAC_ADDR)
  #define DCRCDATA         (*(volatile uint32_t *)(0x40 + _DMAC_ADDR)
  #define DCRCDATA_CLR     (*(volatile uint32_t *)(0x44 + _DMAC_ADDR)
  #define DCRCDATA_SET     (*(volatile uint32_t *)(0x48 + _DMAC_ADDR)
  #define DCRCDATA_INV     (*(volatile uint32_t *)(0x4C + _DMAC_ADDR)
  #define DCRCXOR          (*(volatile uint32_t *)(0x50 + _DMAC_ADDR)
  #define DCRCXOR_CLR      (*(volatile uint32_t *)(0x54 + _DMAC_ADDR)
  #define DCRCXOR_SET      (*(volatile uint32_t *)(0x58 + _DMAC_ADDR)
  #define DCRCXOR_INV      (*(volatile uint32_t *)(0x5C + _DMAC_ADDR)

  #define DCH_CON(x)          (*(volatile uint32_t *)(0x00 + _DMAC_CH_ADDR(x)))
  #define DCH_CON_CLR(x)      (*(volatile uint32_t *)(0x04 + _DMAC_CH_ADDR(x)))
  #define DCH_CON_SET(x)      (*(volatile uint32_t *)(0x08 + _DMAC_CH_ADDR(x)))
  #define DCH_CON_INV(x)      (*(volatile uint32_t *)(0x0C + _DMAC_CH_ADDR(x)))
  #define DCH_ECON(x)         (*(volatile uint32_t *)(0x10 + _DMAC_CH_ADDR(x)))
  #define DCH_ECON_CLR(x)     (*(volatile uint32_t *)(0x14 + _DMAC_CH_ADDR(x)))
  #define DCH_ECON_SET(x)     (*(volatile uint32_t *)(0x18 + _DMAC_CH_ADDR(x)))
  #define DCH_ECON_INV(x)     (*(volatile uint32_t *)(0x1C + _DMAC_CH_ADDR(x)))
  #define DCH_INT(x)          (*(volatile uint32_t *)(0x20 + _DMAC_CH_ADDR(x)))
  #define DCH_INT_CLR(x)      (*(volatile uint32_t *)(0x24 + _DMAC_CH_ADDR(x)))
  #define DCH_INT_SET(x)      (*(volatile uint32_t *)(0x28 + _DMAC_CH_ADDR(x)))
  #define DCH_INT_INV(x)      (*(volatile uint32_t *)(0x2C + _DMAC_CH_ADDR(x)))
  #define DCH_SSA(x)          (*(volatile uint32_t *)(0x30 + _DMAC_CH_ADDR(x)))
  #define DCH_SSA_CLR(x)      (*(volatile uint32_t *)(0x34 + _DMAC_CH_ADDR(x)))
  #define DCH_SSA_SET(x)      (*(volatile uint32_t *)(0x38 + _DMAC_CH_ADDR(x)))
  #define DCH_SSA_INV(x)      (*(volatile uint32_t *)(0x3C + _DMAC_CH_ADDR(x)))
  #define DCH_DSA(x)          (*(volatile uint32_t *)(0x40 + _DMAC_CH_ADDR(x)))
  #define DCH_DSA_CLR(x)      (*(volatile uint32_t *)(0x44 + _DMAC_CH_ADDR(x)))
  #define DCH_DSA_SET(x)      (*(volatile uint32_t *)(0x48 + _DMAC_CH_ADDR(x)))
  #define DCH_DSA_INV(x)      (*(volatile uint32_t *)(0x4C + _DMAC_CH_ADDR(x)))
  #define DCH_SSIZ(x)         (*(volatile uint32_t *)(0x50 + _DMAC_CH_ADDR(x)))
  #define DCH_SSIZ_CLR(x)     (*(volatile uint32_t *)(0x54 + _DMAC_CH_ADDR(x)))
  #define DCH_SSIZ_SET(x)     (*(volatile uint32_t *)(0x58 + _DMAC_CH_ADDR(x)))
  #define DCH_SSIZ_INV(x)     (*(volatile uint32_t *)(0x5C + _DMAC_CH_ADDR(x)))
  #define DCH_DSIZ(x)         (*(volatile uint32_t *)(0x60 + _DMAC_CH_ADDR(x)))
  #define DCH_DSIZ_CLR(x)     (*(volatile uint32_t *)(0x64 + _DMAC_CH_ADDR(x)))
  #define DCH_DSIZ_SET(x)     (*(volatile uint32_t *)(0x68 + _DMAC_CH_ADDR(x)))
  #define DCH_DSIZ_INV(x)     (*(volatile uint32_t *)(0x6C + _DMAC_CH_ADDR(x)))
  #define DCH_SPTR(x)         (*(volatile uint32_t *)(0x70 + _DMAC_CH_ADDR(x)))
  #define DCH_SPTR_CLR(x)     (*(volatile uint32_t *)(0x74 + _DMAC_CH_ADDR(x)))
  #define DCH_SPTR_SET(x)     (*(volatile uint32_t *)(0x78 + _DMAC_CH_ADDR(x)))
  #define DCH_SPTR_INV(x)     (*(volatile uint32_t *)(0x7C + _DMAC_CH_ADDR(x)))
  #define DCH_DPTR(x)         (*(volatile uint32_t *)(0x80 + _DMAC_CH_ADDR(x)))
  #define DCH_DPTR_CLR(x)     (*(volatile uint32_t *)(0x84 + _DMAC_CH_ADDR(x)))
  #define DCH_DPTR_SET(x)     (*(volatile uint32_t *)(0x88 + _DMAC_CH_ADDR(x)))
  #define DCH_DPTR_INV(x)     (*(volatile uint32_t *)(0x8C + _DMAC_CH_ADDR(x)))
  #define DCH_CSIZ(x)         (*(volatile uint32_t *)(0x90 + _DMAC_CH_ADDR(x)))
  #define DCH_CSIZ_CLR(x)     (*(volatile uint32_t *)(0x94 + _DMAC_CH_ADDR(x)))
  #define DCH_CSIZ_SET(x)     (*(volatile uint32_t *)(0x98 + _DMAC_CH_ADDR(x)))
  #define DCH_CSIZ_INV(x)     (*(volatile uint32_t *)(0x9C + _DMAC_CH_ADDR(x)))
  #define DCH_CPTR(x)         (*(volatile uint32_t *)(0xA0 + _DMAC_CH_ADDR(x)))
  #define DCH_CPTR_CLR(x)     (*(volatile uint32_t *)(0xA4 + _DMAC_CH_ADDR(x)))
  #define DCH_CPTR_SET(x)     (*(volatile uint32_t *)(0xA8 + _DMAC_CH_ADDR(x)))
  #define DCH_CPTR_INV(x)     (*(volatile uint32_t *)(0xAC + _DMAC_CH_ADDR(x)))
  #define DCH_DAT(x)          (*(volatile uint32_t *)(0xB0 + _DMAC_CH_ADDR(x)))
  #define DCH_DAT_CLR(x)      (*(volatile uint32_t *)(0xB4 + _DMAC_CH_ADDR(x)))
  #define DCH_DAT_SET(x)      (*(volatile uint32_t *)(0xB8 + _DMAC_CH_ADDR(x)))
  #define DCH_DAT_INV(x)      (*(volatile uint32_t *)(0xBC + _DMAC_CH_ADDR(x)))
#else
  #define DMACON           (*(volatile uint32_t *)0xBF883000)
  #define DMACON_CLR       (*(volatile uint32_t *)0xBF883004)
  #define DMACON_SET       (*(volatile uint32_t *)0xBF883008)
  #define DMACON_INV       (*(volatile uint32_t *)0xBF88300C)
  #define DMASTAT          (*(volatile uint32_t *)0xBF883010)
  #define DMASTAT_CLR      (*(volatile uint32_t *)0xBF883014)
  #define DMASTAT_SET      (*(volatile uint32_t *)0xBF883018)
  #define DMASTAT_INV      (*(volatile uint32_t *)0xBF88301C)
  #define DMAADDR          (*(volatile uint32_t *)0xBF883020)
  #define DMAADDR_CLR      (*(volatile uint32_t *)0xBF883024)
  #define DMAADDR_SET      (*(volatile uint32_t *)0xBF883028)
  #define DMAADDR_INV      (*(volatile uint32_t *)0xBF88302C)
  #define DCRCCON          (*(volatile uint32_t *)0xBF883030)
  #define DCRCCON_CLR      (*(volatile uint32_t *)0xBF883034)
  #define DCRCCON_SET      (*(volatile uint32_t *)0xBF883038)
  #define DCRCCON_INV      (*(volatile uint32_t *)0xBF88303C)
  #define DCRCDATA         (*(volatile uint32_t *)0xBF883040)
  #define DCRCDATA_CLR     (*(volatile uint32_t *)0xBF883044)
  #define DCRCDATA_SET     (*(volatile uint32_t *)0xBF883048)
  #define DCRCDATA_INV     (*(volatile uint32_t *)0xBF88304C)
  #define DCRCXOR          (*(volatile uint32_t *)0xBF883050)
  #define DCRCXOR_CLR      (*(volatile uint32_t *)0xBF883054)
  #define DCRCXOR_SET      (*(volatile uint32_t *)0xBF883058)
  #define DCRCXOR_INV      (*(volatile uint32_t *)0xBF88305C)

  #define DCH_CON(x)          (*(volatile uint32_t *)(0xBF883060 + (x)*0xc0))
  #define DCH_CON_CLR(x)      (*(volatile uint32_t *)(0xBF883064 + (x)*0xc0))
  #define DCH_CON_SET(x)      (*(volatile uint32_t *)(0xBF883068 + (x)*0xc0))
  #define DCH_CON_INV(x)      (*(volatile uint32_t *)(0xBF88306C + (x)*0xc0))
  #define DCH_ECON(x)         (*(volatile uint32_t *)(0xBF883070 + (x)*0xc0))
  #define DCH_ECON_CLR(x)     (*(volatile uint32_t *)(0xBF883074 + (x)*0xc0))
  #define DCH_ECON_SET(x)     (*(volatile uint32_t *)(0xBF883078 + (x)*0xc0))
  #define DCH_ECON_INV(x)     (*(volatile uint32_t *)(0xBF88307C + (x)*0xc0))
  #define DCH_INT(x)          (*(volatile uint32_t *)(0xBF883080 + (x)*0xc0))
  #define DCH_INT_CLR(x)      (*(volatile uint32_t *)(0xBF883084 + (x)*0xc0))
  #define DCH_INT_SET(x)      (*(volatile uint32_t *)(0xBF883088 + (x)*0xc0))
  #define DCH_INT_INV(x)      (*(volatile uint32_t *)(0xBF88308C + (x)*0xc0))
  #define DCH_SSA(x)          (*(volatile uint32_t *)(0xBF883090 + (x)*0xc0))
  #define DCH_SSA_CLR(x)      (*(volatile uint32_t *)(0xBF883094 + (x)*0xc0))
  #define DCH_SSA_SET(x)      (*(volatile uint32_t *)(0xBF883098 + (x)*0xc0))
  #define DCH_SSA_INV(x)      (*(volatile uint32_t *)(0xBF88309C + (x)*0xc0))
  #define DCH_DSA(x)          (*(volatile uint32_t *)(0xBF8830A0 + (x)*0xc0))
  #define DCH_DSA_CLR(x)      (*(volatile uint32_t *)(0xBF8830A4 + (x)*0xc0))
  #define DCH_DSA_SET(x)      (*(volatile uint32_t *)(0xBF8830A8 + (x)*0xc0))
  #define DCH_DSA_INV(x)      (*(volatile uint32_t *)(0xBF8830AC + (x)*0xc0))
  #define DCH_SSIZ(x)         (*(volatile uint32_t *)(0xBF8830B0 + (x)*0xc0))
  #define DCH_SSIZ_CLR(x)     (*(volatile uint32_t *)(0xBF8830B4 + (x)*0xc0))
  #define DCH_SSIZ_SET(x)     (*(volatile uint32_t *)(0xBF8830B8 + (x)*0xc0))
  #define DCH_SSIZ_INV(x)     (*(volatile uint32_t *)(0xBF8830BC + (x)*0xc0))
  #define DCH_DSIZ(x)         (*(volatile uint32_t *)(0xBF8830C0 + (x)*0xc0))
  #define DCH_DSIZ_CLR(x)     (*(volatile uint32_t *)(0xBF8830C4 + (x)*0xc0))
  #define DCH_DSIZ_SET(x)     (*(volatile uint32_t *)(0xBF8830C8 + (x)*0xc0))
  #define DCH_DSIZ_INV(x)     (*(volatile uint32_t *)(0xBF8830CC + (x)*0xc0))
  #define DCH_SPTR(x)         (*(volatile uint32_t *)(0xBF8830D0 + (x)*0xc0))
  #define DCH_SPTR_CLR(x)     (*(volatile uint32_t *)(0xBF8830D4 + (x)*0xc0))
  #define DCH_SPTR_SET(x)     (*(volatile uint32_t *)(0xBF8830D8 + (x)*0xc0))
  #define DCH_SPTR_INV(x)     (*(volatile uint32_t *)(0xBF8830DC + (x)*0xc0))
  #define DCH_DPTR(x)         (*(volatile uint32_t *)(0xBF8830E0 + (x)*0xc0))
  #define DCH_DPTR_CLR(x)     (*(volatile uint32_t *)(0xBF8830E4 + (x)*0xc0))
  #define DCH_DPTR_SET(x)     (*(volatile uint32_t *)(0xBF8830E8 + (x)*0xc0))
  #define DCH_DPTR_INV(x)     (*(volatile uint32_t *)(0xBF8830EC + (x)*0xc0))
  #define DCH_CSIZ(x)         (*(volatile uint32_t *)(0xBF8830F0 + (x)*0xc0))
  #define DCH_CSIZ_CLR(x)     (*(volatile uint32_t *)(0xBF8830F4 + (x)*0xc0))
  #define DCH_CSIZ_SET(x)     (*(volatile uint32_t *)(0xBF8830F8 + (x)*0xc0))
  #define DCH_CSIZ_INV(x)     (*(volatile uint32_t *)(0xBF8830FC + (x)*0xc0))
  #define DCH_CPTR(x)         (*(volatile uint32_t *)(0xBF883100 + (x)*0xc0))
  #define DCH_CPTR_CLR(x)     (*(volatile uint32_t *)(0xBF883104 + (x)*0xc0))
  #define DCH_CPTR_SET(x)     (*(volatile uint32_t *)(0xBF883108 + (x)*0xc0))
  #define DCH_CPTR_INV(x)     (*(volatile uint32_t *)(0xBF88310C + (x)*0xc0))
  #define DCH_DAT(x)          (*(volatile uint32_t *)(0xBF883110 + (x)*0xc0))
  #define DCH_DAT_CLR(x)      (*(volatile uint32_t *)(0xBF883114 + (x)*0xc0))
  #define DCH_DAT_SET(x)      (*(volatile uint32_t *)(0xBF883118 + (x)*0xc0))
  #define DCH_DAT_INV(x)      (*(volatile uint32_t *)(0xBF88311C + (x)*0xc0))
#endif
    #define DMACON_DMABUSY                 0x0B
    #define DMACON_SUSPEND                 0x0C
    #define DMACON_ON                      0x0F
    #define DMASTAT_DMACH                  0x00
    #define DMASTAT_RDWR                   0x03

    #define DCRCCON_CRCCH                  0x00
    #define DCRCCON_CRCTYP                 0x05
    #define DCRCCON_CRCAPP                 0x06
    #define DCRCCON_CRCEN                  0x07
    #define DCRCCON_PLEN                   0x08
    #define DCRCCON_BITO                   0x18
    #define DCRCCON_WBO                    0x1B
    #define DCRCCON_BYTO                   0x1C

    #define DCH_CON_CHPRI                  0x00
    #define DCH_CON_CHEDET                 0x02
    #define DCH_CON_CHAEN                  0x04
    #define DCH_CON_CHCHN                  0x05
    #define DCH_CON_CHAED                  0x06
    #define DCH_CON_CHEN                   0x07
    #define DCH_CON_CHCHNS                 0x08
    #define DCH_CON_CHBUSY                 0x0F
    #define DCH_ECON_AIRQEN                0x03
    #define DCH_ECON_SIRQEN                0x04
    #define DCH_ECON_PATEN                 0x05
    #define DCH_ECON_CABORT                0x06
    #define DCH_ECON_CFORCE                0x07
    #define DCH_ECON_CHSIRQ                0x08
    #define DCH_ECON_CHAIRQ                0x10
    #define DCH_INT_CHERIF                 0x00
    #define DCH_INT_CHTAIF                 0x01
    #define DCH_INT_CHCCIF                 0x02
    #define DCH_INT_CHBCIF                 0x03
    #define DCH_INT_CHDHIF                 0x04
    #define DCH_INT_CHDDIF                 0x05
    #define DCH_INT_CHSHIF                 0x06
    #define DCH_INT_CHSDIF                 0x07
    #define DCH_INT_CHERIE                 0x10
    #define DCH_INT_CHTAIE                 0x11
    #define DCH_INT_CHCCIE                 0x12
    #define DCH_INT_CHBCIE                 0x13
    #define DCH_INT_CHDHIE                 0x14
    #define DCH_INT_CHDDIE                 0x15
    #define DCH_INT_CHSHIE                 0x16
    #define DCH_INT_CHSDIE                 0x17
#endif /* _JZ_P32MX_DMAC_H_ */
