#ifndef _JZ_P32MX_I2C_H_
#define _JZ_P32MX_I2C_H_
#include <stdint.h>

extern unsigned _i2c_base_addr;  // = 0xBF805000;
#define _I2C_ADDR(x)	(_i2c_base_addr + (x)*0x100)

#ifdef _USE_BASE_ADDR
  /* x=0: I2C1 x=1: I2C2 */
  #define I2C_CON(x)          (*(volatile uint16_t *)(0x00 + _I2C_ADDR(x)))
  #define I2C_CON_CLR(x)      (*(volatile uint16_t *)(0x04 + _I2C_ADDR(x)))
  #define I2C_CON_SET(x)      (*(volatile uint16_t *)(0x08 + _I2C_ADDR(x)))
  #define I2C_CON_INV(x)      (*(volatile uint16_t *)(0x0C + _I2C_ADDR(x)))

  #define I2C_STAT(x)         (*(volatile uint16_t *)(0x10 + _I2C_ADDR(x)))
  #define I2C_STAT_CLR(x)     (*(volatile uint16_t *)(0x14 + _I2C_ADDR(x)))
  #define I2C_STAT_SET(x)     (*(volatile uint16_t *)(0x18 + _I2C_ADDR(x)))
  #define I2C_STAT_INV(x)     (*(volatile uint16_t *)(0x1C + _I2C_ADDR(x)))

  #define I2C_ADD(x)          (*(volatile uint16_t *)(0x20 + _I2C_ADDR(x)))
  #define I2C_ADD_CLR(x)      (*(volatile uint16_t *)(0x24 + _I2C_ADDR(x)))
  #define I2C_ADD_SET(x)      (*(volatile uint16_t *)(0x28 + _I2C_ADDR(x)))
  #define I2C_ADD_INV(x)      (*(volatile uint16_t *)(0x2C + _I2C_ADDR(x)))

  #define I2C_MSK(x)          (*(volatile uint16_t *)(0x30 + _I2C_ADDR(x)))
  #define I2C_MSK_CLR(x)      (*(volatile uint16_t *)(0x34 + _I2C_ADDR(x)))
  #define I2C_MSK_SET(x)      (*(volatile uint16_t *)(0x38 + _I2C_ADDR(x)))
  #define I2C_MSK_INV(x)      (*(volatile uint16_t *)(0x3C + _I2C_ADDR(x)))

  #define I2C_BRG(x)          (*(volatile uint16_t *)(0x40 + _I2C_ADDR(x)))
  #define I2C_BRG_CLR(x)      (*(volatile uint16_t *)(0x44 + _I2C_ADDR(x)))
  #define I2C_BRG_SET(x)      (*(volatile uint16_t *)(0x48 + _I2C_ADDR(x)))
  #define I2C_BRG_INV(x)      (*(volatile uint16_t *)(0x4C + _I2C_ADDR(x)))

  #define I2C_TRN(x)          (*(volatile uint8_t  *)(0x50 + _I2C_ADDR(x)))
  #define I2C_TRN_CLR(x)      (*(volatile uint8_t  *)(0x54 + _I2C_ADDR(x)))
  #define I2C_TRN_SET(x)      (*(volatile uint8_t  *)(0x58 + _I2C_ADDR(x)))
  #define I2C_TRN_INV(x)      (*(volatile uint8_t  *)(0x5C + _I2C_ADDR(x)))

  #define I2C_RCV(x)          (*(volatile uint8_t  *)(0x60 + _I2C_ADDR(x)))
#else
  /* x=0: I2C1 x=1: I2C2 */
  #define I2C_CON(x)          (*(volatile uint16_t *)(0xBF805000 + 0x100*(x)))
  #define I2C_CON_CLR(x)      (*(volatile uint16_t *)(0xBF805004 + 0x100*(x)))
  #define I2C_CON_SET(x)      (*(volatile uint16_t *)(0xBF805008 + 0x100*(x)))
  #define I2C_CON_INV(x)      (*(volatile uint16_t *)(0xBF80500C + 0x100*(x)))

  #define I2C_STAT(x)         (*(volatile uint16_t *)(0xBF805010 + 0x100*(x)))
  #define I2C_STAT_CLR(x)     (*(volatile uint16_t *)(0xBF805014 + 0x100*(x)))
  #define I2C_STAT_SET(x)     (*(volatile uint16_t *)(0xBF805018 + 0x100*(x)))
  #define I2C_STAT_INV(x)     (*(volatile uint16_t *)(0xBF80501C + 0x100*(x)))

  #define I2C_ADD(x)          (*(volatile uint16_t *)(0xBF805020 + 0x100*(x)))
  #define I2C_ADD_CLR(x)      (*(volatile uint16_t *)(0xBF805024 + 0x100*(x)))
  #define I2C_ADD_SET(x)      (*(volatile uint16_t *)(0xBF805028 + 0x100*(x)))
  #define I2C_ADD_INV(x)      (*(volatile uint16_t *)(0xBF80502C + 0x100*(x)))

  #define I2C_MSK(x)          (*(volatile uint16_t *)(0xBF805030 + 0x100*(x)))
  #define I2C_MSK_CLR(x)      (*(volatile uint16_t *)(0xBF805034 + 0x100*(x)))
  #define I2C_MSK_SET(x)      (*(volatile uint16_t *)(0xBF805038 + 0x100*(x)))
  #define I2C_MSK_INV(x)      (*(volatile uint16_t *)(0xBF80503C + 0x100*(x)))

  #define I2C_BRG(x)          (*(volatile uint16_t *)(0xBF805040 + 0x100*(x)))
  #define I2C_BRG_CLR(x)      (*(volatile uint16_t *)(0xBF805044 + 0x100*(x)))
  #define I2C_BRG_SET(x)      (*(volatile uint16_t *)(0xBF805048 + 0x100*(x)))
  #define I2C_BRG_INV(x)      (*(volatile uint16_t *)(0xBF80504C + 0x100*(x)))

  #define I2C_TRN(x)          (*(volatile uint8_t  *)(0xBF805050 + 0x100*(x)))
  #define I2C_TRN_CLR(x)      (*(volatile uint8_t  *)(0xBF805054 + 0x100*(x)))
  #define I2C_TRN_SET(x)      (*(volatile uint8_t  *)(0xBF805058 + 0x100*(x)))
  #define I2C_TRN_INV(x)      (*(volatile uint8_t  *)(0xBF80505C + 0x100*(x)))

  #define I2C_RCV(x)          (*(volatile uint8_t  *)(0xBF805060 + 0x100*(x)))
#endif
    #define I2C_CON_SEN                    0x00
    #define I2C_CON_RSEN                   0x01
    #define I2C_CON_PEN                    0x02
    #define I2C_CON_RCEN                   0x03
    #define I2C_CON_ACKEN                  0x04
    #define I2C_CON_ACKDT                  0x05
    #define I2C_CON_STREN                  0x06
    #define I2C_CON_GCEN                   0x07
    #define I2C_CON_SMEN                   0x08
    #define I2C_CON_DISSLW                 0x09
    #define I2C_CON_A10M                   0x0A
    #define I2C_CON_STRICT                 0x0B
    #define I2C_CON_SCLREL                 0x0C
    #define I2C_CON_SIDL                   0x0D
    #define I2C_CON_ON                     0x0F
    #define I2C_CON_IPMIEN                 0x0B
    #define I2C_CON_I2CSIDL                0x0D
    #define I2C_CON_I2CEN                  0x0F

    #define I2C_STAT_TBF                   0x00
    #define I2C_STAT_RBF                   0x01
    #define I2C_STAT_R_W                   0x02
    #define I2C_STAT_S                     0x03
    #define I2C_STAT_P                     0x04
    #define I2C_STAT_D_A                   0x05
    #define I2C_STAT_I2COV                 0x06
    #define I2C_STAT_IWCOL                 0x07
    #define I2C_STAT_ADD10                 0x08
    #define I2C_STAT_GCSTAT                0x09
    #define I2C_STAT_BCL                   0x0A
    #define I2C_STAT_TRSTAT                0x0E
    #define I2C_STAT_ACKSTAT               0x0F
    #define I2C_STAT_I2CPOV                0x06

#endif /* _JZ_P32MX_I2C_H_ */
