#ifndef _JZ_PIC32MX_PORT_H_
#define _JZ_PIC32MX_PORT_H_
#include <stdint.h>

#ifdef _USE_BASE_ADDR
extern unsigned _port_base_addr;  // = 0xBF886000;
#define _PORT_ADDR(x)	(_port_base_addr + (x)*0x100)

  /* x=0:PORTA , x=1:PORTB , x=2:PORTC */
  #define ANSEL(x)           (*(volatile uint16_t *)(0x00 + _PORT_ADDR(x)))
  #define ANSEL_CLR(x)       (*(volatile uint16_t *)(0x04 + _PORT_ADDR(x)))
  #define ANSEL_SET(x)       (*(volatile uint16_t *)(0x08 + _PORT_ADDR(x)))
  #define ANSEL_INV(x)       (*(volatile uint16_t *)(0x0C + _PORT_ADDR(x)))

  #define TRIS(x)            (*(volatile uint16_t *)(0x10 + _PORT_ADDR(x)))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(0x14 + _PORT_ADDR(x)))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(0x18 + _PORT_ADDR(x)))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(0x1C + _PORT_ADDR(x)))

  #define PORT(x)            (*(volatile uint16_t *)(0x20 + _PORT_ADDR(x)))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(0x24 + _PORT_ADDR(x)))
  #define PORT_SET(x)        (*(volatile uint16_t *)(0x28 + _PORT_ADDR(x)))
  #define PORT_INV(x)        (*(volatile uint16_t *)(0x2C + _PORT_ADDR(x)))

  #define LAT(x)             (*(volatile uint16_t *)(0x30 + _PORT_ADDR(x)))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(0x34 + _PORT_ADDR(x)))
  #define LAT_SET(x)         (*(volatile uint16_t *)(0x38 + _PORT_ADDR(x)))
  #define LAT_INV(x)         (*(volatile uint16_t *)(0x3C + _PORT_ADDR(x)))

  #define ODC(x)             (*(volatile uint16_t *)(0x40 + _PORT_ADDR(x)))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(0x44 + _PORT_ADDR(x)))
  #define ODC_SET(x)         (*(volatile uint16_t *)(0x48 + _PORT_ADDR(x)))
  #define ODC_INV(x)         (*(volatile uint16_t *)(0x4C + _PORT_ADDR(x)))

  #define CNPU(x)            (*(volatile uint16_t *)(0x50 + _PORT_ADDR(x)))
  #define CNPU_CLR(x)        (*(volatile uint16_t *)(0x54 + _PORT_ADDR(x)))
  #define CNPU_SET(x)        (*(volatile uint16_t *)(0x58 + _PORT_ADDR(x)))
  #define CNPU_INV(x)        (*(volatile uint16_t *)(0x5C + _PORT_ADDR(x)))

  #define CNPD(x)            (*(volatile uint16_t *)(0x60 + _PORT_ADDR(x)))
  #define CNPD_CLR(x)        (*(volatile uint16_t *)(0x64 + _PORT_ADDR(x)))
  #define CNPD_SET(x)        (*(volatile uint16_t *)(0x68 + _PORT_ADDR(x)))
  #define CNPD_INV(x)        (*(volatile uint16_t *)(0x6C + _PORT_ADDR(x)))

  #define CNCON(x)           (*(volatile uint16_t *)(0x70 + _PORT_ADDR(x)))
  #define CNCON_CLR(x)       (*(volatile uint16_t *)(0x74 + _PORT_ADDR(x)))
  #define CNCON_SET(x)       (*(volatile uint16_t *)(0x78 + _PORT_ADDR(x)))
  #define CNCON_INV(x)       (*(volatile uint16_t *)(0x7C + _PORT_ADDR(x)))

  #define CNEN(x)            (*(volatile uint16_t *)(0x80 + _PORT_ADDR(x)))
  #define CNEN_CLR(x)        (*(volatile uint16_t *)(0x84 + _PORT_ADDR(x)))
  #define CNEN_SET(x)        (*(volatile uint16_t *)(0x88 + _PORT_ADDR(x)))
  #define CNEN_INV(x)        (*(volatile uint16_t *)(0x8C + _PORT_ADDR(x)))

  #define CNSTAT(x)          (*(volatile uint16_t *)(0x90 + _PORT_ADDR(x)))
  #define CNSTAT_CLR(x)      (*(volatile uint16_t *)(0x94 + _PORT_ADDR(x)))
  #define CNSTAT_SET(x)      (*(volatile uint16_t *)(0x98 + _PORT_ADDR(x)))
  #define CNSTAT_INV(x)      (*(volatile uint16_t *)(0x9C + _PORT_ADDR(x)))
#else
  #define ANSEL(x)           (*(volatile uint16_t *)(0xBF886000 + (x)*0x100))
  #define ANSEL_CLR(x)       (*(volatile uint16_t *)(0xBF886004 + (x)*0x100))
  #define ANSEL_SET(x)       (*(volatile uint16_t *)(0xBF886008 + (x)*0x100))
  #define ANSEL_INV(x)       (*(volatile uint16_t *)(0xBF88600C + (x)*0x100))

  #define TRIS(x)            (*(volatile uint16_t *)(0xBF886010 + (x)*0x100))
  #define TRIS_CLR(x)        (*(volatile uint16_t *)(0xBF886014 + (x)*0x100))
  #define TRIS_SET(x)        (*(volatile uint16_t *)(0xBF886018 + (x)*0x100))
  #define TRIS_INV(x)        (*(volatile uint16_t *)(0xBF88601C + (x)*0x100))

  #define PORT(x)            (*(volatile uint16_t *)(0xBF886020 + (x)*0x100))
  #define PORT_CLR(x)        (*(volatile uint16_t *)(0xBF886024 + (x)*0x100))
  #define PORT_SET(x)        (*(volatile uint16_t *)(0xBF886028 + (x)*0x100))
  #define PORT_INV(x)        (*(volatile uint16_t *)(0xBF88602C + (x)*0x100))

  #define LAT(x)             (*(volatile uint16_t *)(0xBF886030 + (x)*0x100))
  #define LAT_CLR(x)         (*(volatile uint16_t *)(0xBF886034 + (x)*0x100))
  #define LAT_SET(x)         (*(volatile uint16_t *)(0xBF886038 + (x)*0x100))
  #define LAT_INV(x)         (*(volatile uint16_t *)(0xBF88603C + (x)*0x100))

  #define ODC(x)             (*(volatile uint16_t *)(0xBF886040 + (x)*0x100))
  #define ODC_CLR(x)         (*(volatile uint16_t *)(0xBF886044 + (x)*0x100))
  #define ODC_SET(x)         (*(volatile uint16_t *)(0xBF886048 + (x)*0x100))
  #define ODC_INV(x)         (*(volatile uint16_t *)(0xBF88604C + (x)*0x100))

  #define CNPU(x)            (*(volatile uint16_t *)(0xBF886050 + (x)*0x100))
  #define CNPU_CLR(x)        (*(volatile uint16_t *)(0xBF886054 + (x)*0x100))
  #define CNPU_SET(x)        (*(volatile uint16_t *)(0xBF886058 + (x)*0x100))
  #define CNPU_INV(x)        (*(volatile uint16_t *)(0xBF88605C + (x)*0x100))

  #define CNPD(x)            (*(volatile uint16_t *)(0xBF886060 + (x)*0x100))
  #define CNPD_CLR(x)        (*(volatile uint16_t *)(0xBF886064 + (x)*0x100))
  #define CNPD_SET(x)        (*(volatile uint16_t *)(0xBF886068 + (x)*0x100))
  #define CNPD_INV(x)        (*(volatile uint16_t *)(0xBF88606C + (x)*0x100))

  #define CNCON(x)           (*(volatile uint16_t *)(0xBF886070 + (x)*0x100))
  #define CNCON_CLR(x)       (*(volatile uint16_t *)(0xBF886074 + (x)*0x100))
  #define CNCON_SET(x)       (*(volatile uint16_t *)(0xBF886078 + (x)*0x100))
  #define CNCON_INV(x)       (*(volatile uint16_t *)(0xBF88607C + (x)*0x100))

  #define CNEN(x)            (*(volatile uint16_t *)(0xBF886080 + (x)*0x100))
  #define CNEN_CLR(x)        (*(volatile uint16_t *)(0xBF886084 + (x)*0x100))
  #define CNEN_SET(x)        (*(volatile uint16_t *)(0xBF886088 + (x)*0x100))
  #define CNEN_INV(x)        (*(volatile uint16_t *)(0xBF88608C + (x)*0x100))

  #define CNSTAT(x)          (*(volatile uint16_t *)(0xBF886090 + (x)*0x100))
  #define CNSTAT_CLR(x)      (*(volatile uint16_t *)(0xBF886094 + (x)*0x100))
  #define CNSTAT_SET(x)      (*(volatile uint16_t *)(0xBF886098 + (x)*0x100))
  #define CNSTAT_INV(x)      (*(volatile uint16_t *)(0xBF88609C + (x)*0x100))
#endif

    #define CNCONx_SIDL     0x0D
    #define CNCONx_ON       0x0F

#endif /* _JZ_PIC32MX_PORT_H_ */
