#ifndef _JZ_P32MX_SPI_H_
#define _JZ_P32MX_SPI_H_
#include <stdint.h>

#ifdef _USE_BASE_ADDR
extern unsigned _spi_base_addr;  // = BF805800;
#define _SPI_ADDR(x)	(_spi_base_addr + (x)*0x200)

  /* x=0: SPI1 x=1:SPI2 */
  #define SPI_CON(x)          (*(volatile unsigned *)(0x00 + _SPI_ADDR(x)))
  #define SPI_CON_CLR(x)      (*(volatile unsigned *)(0x04 + _SPI_ADDR(x)))
  #define SPI_CON_SET(x)      (*(volatile unsigned *)(0x08 + _SPI_ADDR(x)))
  #define SPI_CON_INV(x)      (*(volatile unsigned *)(0x0C + _SPI_ADDR(x)))
  #define SPI_STAT(x)         (*(volatile unsigned *)(0x10 + _SPI_ADDR(x)))
  #define SPI_STAT_CLR(x)     (*(volatile unsigned *)(0x14 + _SPI_ADDR(x)))
  #define SPI_STAT_SET(x)     (*(volatile unsigned *)(0x18 + _SPI_ADDR(x)))
  #define SPI_STAT_INV(x)     (*(volatile unsigned *)(0x1C + _SPI_ADDR(x)))
  #define SPI_BUF(x)          (*(volatile unsigned *)(0x20 + _SPI_ADDR(x)))
  #define SPI_BRG(x)          (*(volatile unsigned *)(0x30 + _SPI_ADDR(x)))
  #define SPI_BRG_CLR(x)      (*(volatile unsigned *)(0x34 + _SPI_ADDR(x)))
  #define SPI_BRG_SET(x)      (*(volatile unsigned *)(0x38 + _SPI_ADDR(x)))
  #define SPI_BRG_INV(x)      (*(volatile unsigned *)(0x3C + _SPI_ADDR(x)))
  #define SPI_CON2(x)         (*(volatile unsigned *)(0x40 + _SPI_ADDR(x)))
  #define SPI_CON2_CLR(x)     (*(volatile unsigned *)(0x44 + _SPI_ADDR(x)))
  #define SPI_CON2_SET(x)     (*(volatile unsigned *)(0x48 + _SPI_ADDR(x)))
  #define SPI_CON2_INV(x)     (*(volatile unsigned *)(0x4C + _SPI_ADDR(x)))
#else
  /* x=0: SPI1 x=1:SPI2 */
  #define SPI_CON(x)          (*(volatile unsigned *)(0xBF805800 +(x)*0x200))
  #define SPI_CON_CLR(x)      (*(volatile unsigned *)(0xBF805804 +(x)*0x200))
  #define SPI_CON_SET(x)      (*(volatile unsigned *)(0xBF805808 +(x)*0x200))
  #define SPI_CON_INV(x)      (*(volatile unsigned *)(0xBF80580C +(x)*0x200))
  #define SPI_STAT(x)         (*(volatile unsigned *)(0xBF805810 +(x)*0x200))
  #define SPI_STAT_CLR(x)     (*(volatile unsigned *)(0xBF805814 +(x)*0x200))
  #define SPI_STAT_SET(x)     (*(volatile unsigned *)(0xBF805818 +(x)*0x200))
  #define SPI_STAT_INV(x)     (*(volatile unsigned *)(0xBF80581C +(x)*0x200))
  #define SPI_BUF(x)          (*(volatile unsigned *)(0xBF805820 +(x)*0x200))
  #define SPI_BRG(x)          (*(volatile unsigned *)(0xBF805830 +(x)*0x200))
  #define SPI_BRG_CLR(x)      (*(volatile unsigned *)(0xBF805834 +(x)*0x200))
  #define SPI_BRG_SET(x)      (*(volatile unsigned *)(0xBF805838 +(x)*0x200))
  #define SPI_BRG_INV(x)      (*(volatile unsigned *)(0xBF80583C +(x)*0x200))
  #define SPI_CON2(x)         (*(volatile unsigned *)(0xBF805840 +(x)*0x200))
  #define SPI_CON2_CLR(x)     (*(volatile unsigned *)(0xBF805844 +(x)*0x200))
  #define SPI_CON2_SET(x)     (*(volatile unsigned *)(0xBF805848 +(x)*0x200))
  #define SPI_CON2_INV(x)     (*(volatile unsigned *)(0xBF80584C +(x)*0x200))
#endif
    #define SPI_CON_SRXISEL                0x00
    #define SPI_CON_STXISEL                0x02
    #define SPI_CON_DISSDI                 0x04
    #define SPI_CON_MSTEN                  0x05
    #define SPI_CON_CKP                    0x06
    #define SPI_CON_SSEN                   0x07
    #define SPI_CON_CKE                    0x08
    #define SPI_CON_SMP                    0x09
    #define SPI_CON_MODE16                 0x0A
    #define SPI_CON_MODE32                 0x0B
    #define SPI_CON_DISSDO                 0x0C
    #define SPI_CON_SIDL                   0x0D
    #define SPI_CON_ON                     0x0F
    #define SPI_CON_ENHBUF                 0x10
    #define SPI_CON_SPIFE                  0x11
    #define SPI_CON_MCLKSEL                0x17
    #define SPI_CON_FRMCNT                 0x18
    #define SPI_CON_FRMSYPW                0x1B
    #define SPI_CON_MSSEN                  0x1C
    #define SPI_CON_FRMPOL                 0x1D
    #define SPI_CON_FRMSYNC                0x1E
    #define SPI_CON_FRMEN                  0x1F
    #define SPI_STAT_SPIRBF                0x00
    #define SPI_STAT_SPITBF                0x01
    #define SPI_STAT_SPITBE                0x03
    #define SPI_STAT_SPIRBE                0x05
    #define SPI_STAT_SPIROV                0x06
    #define SPI_STAT_SRMT                  0x07
    #define SPI_STAT_SPITUR                0x08
    #define SPI_STAT_SPIBUSY               0x0B
    #define SPI_STAT_FRMERR                0x0C
    #define SPI_STAT_TXBUFELM              0x10
    #define SPI_STAT_RXBUFELM              0x18
    #define SPI_CON2_AUDMOD                0x00
    #define SPI_CON2_AUDMONO               0x03
    #define SPI_CON2_AUDEN                 0x07
    #define SPI_CON2_IGNTUR                0x08
    #define SPI_CON2_IGNROV                0x09
    #define SPI_CON2_SPITUREN              0x0A
    #define SPI_CON2_SPIROVEN              0x0B
    #define SPI_CON2_FRMERREN              0x0C
    #define SPI_CON2_SPISGNEXT             0x0F
    #define SPI_CON2_AUDMOD0               0x00
    #define SPI_CON2_AUDMOD1               0x01
#endif /* _JZ_P32MX_SPI_H_ */
