#ifndef _JZ_P32MX_TIMER_H_
#define _JZ_P32MX_TIMER_H_
#include <stdint.h>

extern unsigned _timer_base_addr;  // = 0xBF800600;
#define _TIMER_ADDR(x)	(_timer_base_addr + (x)*0x200)

#ifdef _USE_BASE_ADDR
  /* x=0: T1 x=4:T5 */
  #define T_CON(x)           (*(volatile uint16_t *)(0x00 + _TIMER_ADDR(x)))
  #define T_CON_CLR(x)       (*(volatile uint16_t *)(0x04 + _TIMER_ADDR(x)))
  #define T_CON_SET(x)       (*(volatile uint16_t *)(0x08 + _TIMER_ADDR(x)))
  #define T_CON_INV(x)       (*(volatile uint16_t *)(0x0C + _TIMER_ADDR(x)))
  #define TMR(x)             (*(volatile uint16_t *)(0x10 + _TIMER_ADDR(x)))
  #define TMR_CLR(x)         (*(volatile uint16_t *)(0x14 + _TIMER_ADDR(x)))
  #define TMR_SET(x)         (*(volatile uint16_t *)(0x18 + _TIMER_ADDR(x)))
  #define TMR_INV(x)         (*(volatile uint16_t *)(0x1C + _TIMER_ADDR(x)))
  #define PR(x)              (*(volatile uint16_t *)(0x20 + _TIMER_ADDR(x)))
  #define PR_CLR(x)          (*(volatile uint16_t *)(0x24 + _TIMER_ADDR(x)))
  #define PR_SET(x)          (*(volatile uint16_t *)(0x28 + _TIMER_ADDR(x)))
#else
  /* x=0: T1 x=4:T5 */
  #define T_CON(x)           (*(volatile uint16_t *)(0xBF800600 + (x)*0x200))
  #define T_CON_CLR(x)       (*(volatile uint16_t *)(0xBF800604 + (x)*0x200))
  #define T_CON_SET(x)       (*(volatile uint16_t *)(0xBF800608 + (x)*0x200))
  #define T_CON_INV(x)       (*(volatile uint16_t *)(0xBF80060C + (x)*0x200))
  #define TMR(x)             (*(volatile uint16_t *)(0xBF800610 + (x)*0x200))
  #define TMR_CLR(x)         (*(volatile uint16_t *)(0xBF800614 + (x)*0x200))
  #define TMR_SET(x)         (*(volatile uint16_t *)(0xBF800618 + (x)*0x200))
  #define TMR_INV(x)         (*(volatile uint16_t *)(0xBF80061C + (x)*0x200))
  #define PR(x)              (*(volatile uint16_t *)(0xBF800620 + (x)*0x200))
  #define PR_CLR(x)          (*(volatile uint16_t *)(0xBF800624 + (x)*0x200))
  #define PR_SET(x)          (*(volatile uint16_t *)(0xBF800628 + (x)*0x200))
  #define PR_INV(x)          (*(volatile uint16_t *)(0xBF80062C + (x)*0x200))
#endif
    #define T_CON_TCS                     0x01
    #define T_CON_TSYNC                   0x02	// T1 Only
    #define T_CON_T32                     0x03	// T2,T4 Only
    #define T_CON_TCKPS                   0x04
    #define T_CON_TGATE                   0x07
    #define T_CON_TWIP                    0x0B	// T1 Only
    #define T_CON_TWDIS                   0x0C	// T1 Only
    #define T_CON_SIDL                    0x0D
    #define T_CON_ON                      0x0F

#endif /* _JZ_P32MX_TIMER_H_ */
