#ifndef _JZ_P32MX_UART_H_
#define _JZ_P32MX_UART_H_
#include <stdint.h>

#ifdef _USE_BASE_ADDR
extern unsigned _uart_base_addr;  // = 0xBF806000;
#define _UART_ADDR(x)	(_uart_base_addr + (x)*0x200)

  /* x=0:UART1 x=1: UART2 */
  #define U_MODE(x)           (*(volatile uint16_t *)(0x00 + _UART_ADDR(x)))
  #define U_MODE_CLR(x)       (*(volatile uint16_t *)(0x04 + _UART_ADDR(x)))
  #define U_MODE_SET(x)       (*(volatile uint16_t *)(0x08 + _UART_ADDR(x)))
  #define U_MODE_INV(x)       (*(volatile uint16_t *)(0x0C + _UART_ADDR(x)))
  #define U_STA(x)            (*(volatile uint32_t *)(0x10 + _UART_ADDR(x)))
  #define U_STA_CLR(x)        (*(volatile uint32_t *)(0x14 + _UART_ADDR(x)))
  #define U_STA_SET(x)        (*(volatile uint32_t *)(0x18 + _UART_ADDR(x)))
  #define U_STA_INV(x)        (*(volatile uint32_t *)(0x1C + _UART_ADDR(x)))
  #define U_TXREG(x)          (*(volatile uint16_t *)(0x20 + _UART_ADDR(x)))
  #define U_RXREG(x)          (*(volatile uint16_t *)(0x30 + _UART_ADDR(x)))
  #define U_BRG(x)            (*(volatile uint16_t *)(0x40 + _UART_ADDR(x)))
  #define U_BRG_CLR(x)        (*(volatile uint16_t *)(0x44 + _UART_ADDR(x)))
  #define U_BRG_SET(x)        (*(volatile uint16_t *)(0x48 + _UART_ADDR(x)))
  #define U_BRG_INV(x)        (*(volatile uint16_t *)(0x4C + _UART_ADDR(x)))

  #define U_STAh(x)           (*(volatile uint16_t *)(0x10 + _UART_ADDR(x)))
  #define U_STAh_CLR(x)       (*(volatile uint16_t *)(0x14 + _UART_ADDR(x)))
  #define U_STAh_SET(x)       (*(volatile uint16_t *)(0x18 + _UART_ADDR(x)))
  #define U_STAh_INV(x)       (*(volatile uint16_t *)(0x1C + _UART_ADDR(x)))
  #define U_TXREGb(x)         (*(volatile uint8_t  *)(0x20 + _UART_ADDR(x)))
  #define U_RXREGb(x)         (*(volatile uint8_t  *)(0x30 + _UART_ADDR(x)))
#else
  /* x=0:UART1 x=1: UART2 */
  #define U_MODE(x)           (*(volatile uint16_t *)(0xBF806000 + (x)*0x200))
  #define U_MODE_CLR(x)       (*(volatile uint16_t *)(0xBF806004 + (x)*0x200))
  #define U_MODE_SET(x)       (*(volatile uint16_t *)(0xBF806008 + (x)*0x200))
  #define U_MODE_INV(x)       (*(volatile uint16_t *)(0xBF80600C + (x)*0x200))
  #define U_STA(x)            (*(volatile uint32_t *)(0xBF806010 + (x)*0x200))
  #define U_STA_CLR(x)        (*(volatile uint32_t *)(0xBF806014 + (x)*0x200))
  #define U_STA_SET(x)        (*(volatile uint32_t *)(0xBF806018 + (x)*0x200))
  #define U_STA_INV(x)        (*(volatile uint32_t *)(0xBF80601C + (x)*0x200))
  #define U_TXREG(x)          (*(volatile uint16_t *)(0xBF806020 + (x)*0x200))
  #define U_RXREG(x)          (*(volatile uint16_t *)(0xBF806030 + (x)*0x200))
  #define U_BRG(x)            (*(volatile uint16_t *)(0xBF806040 + (x)*0x200))
  #define U_BRG_CLR(x)        (*(volatile uint16_t *)(0xBF806044 + (x)*0x200))
  #define U_BRG_SET(x)        (*(volatile uint16_t *)(0xBF806048 + (x)*0x200))
  #define U_BRG_INV(x)        (*(volatile uint16_t *)(0xBF80604C + (x)*0x200))

  #define U_STAh(x)           (*(volatile uint16_t *)(0xBF806010 + (x)*0x200))
  #define U_STAh_CLR(x)       (*(volatile uint16_t *)(0xBF806014 + (x)*0x200))
  #define U_STAh_SET(x)       (*(volatile uint16_t *)(0xBF806018 + (x)*0x200))
  #define U_STAh_INV(x)       (*(volatile uint16_t *)(0xBF80601C + (x)*0x200))
  #define U_TXREGb(x)         (*(volatile uint8_t  *)(0xBF806020 + (x)*0x200))
  #define U_RXREGb(x)         (*(volatile uint8_t  *)(0xBF806030 + (x)*0x200))
#endif
    #define U_MODE_STSEL	0x00
    #define U_MODE_PDSEL	0x01
    #define U_MODE_BRGH		0x03
    #define U_MODE_RXINV	0x04
    #define U_MODE_ABAUD	0x05
    #define U_MODE_LPBACK	0x06
    #define U_MODE_WAKE		0x07
    #define U_MODE_UEN		0x08
    #define U_MODE_RTSMD	0x0B
    #define U_MODE_IREN		0x0C
    #define U_MODE_SIDL		0x0D
    #define U_MODE_ON		0x0F
    #define U_MODE_PDSEL0	0x01
    #define U_MODE_PDSEL1	0x02
    #define U_MODE_UEN0		0x08
    #define U_MODE_UEN1		0x09
    #define U_MODE_USIDL	0x0D
    #define U_MODE_UARTEN	0x0F

    #define U_STA_URXDA		0x00
    #define U_STA_OERR		0x01
    #define U_STA_FERR		0x02
    #define U_STA_PERR		0x03
    #define U_STA_RIDLE		0x04
    #define U_STA_ADDEN		0x05
    #define U_STA_URXISEL	0x06
    #define U_STA_TRMT		0x08
    #define U_STA_UTXBF		0x09
    #define U_STA_UTXEN		0x0A
    #define U_STA_UTXBRK	0x0B
    #define U_STA_URXEN		0x0C
    #define U_STA_UTXINV	0x0D
    #define U_STA_UTXISEL	0x0E
    #define U_STA_ADDR		0x10
    #define U_STA_ADM_EN	0x18
    #define U_STA_URXISEL0	0x06
    #define U_STA_URXISEL1	0x07
    #define U_STA_UTXISEL0	0x0E
    #define U_STA_UTXISEL1	0x0F
    #define U_STA_UTXSEL	0x0E

#endif /* _JZ_P32MX_UART_H_ */
