#ifndef _JZ_P32MX_USBOTG_H_
#define _JZ_P32MX_USBOTG_H_
#include <stdint.h>

#ifdef _USE_BASE_ADDR
extern unsigned _usbotg_base_addr;  // = 0xBF885000;
#define _USBOTG_ADDR		(_usbotg_base_addr)
#define _USBOTG_EP_ADDR(x)	(_usbotg_base_addr + 0x300 + (x)*0x10)

  #define U_OTGIR          (*(volatile uint8_t *)(0x40 + _USBOTG_ADDR))
  #define U_OTGIR_CLR      (*(volatile uint8_t *)(0x44 + _USBOTG_ADDR))
  #define U_OTGIE          (*(volatile uint8_t *)(0x50 + _USBOTG_ADDR))
  #define U_OTGIE_CLR      (*(volatile uint8_t *)(0x54 + _USBOTG_ADDR))
  #define U_OTGIE_SET      (*(volatile uint8_t *)(0x58 + _USBOTG_ADDR))
  #define U_OTGIE_INV      (*(volatile uint8_t *)(0x5C + _USBOTG_ADDR))
  #define U_OTGSTAT        (*(volatile uint8_t *)(0x60 + _USBOTG_ADDR))
  #define U_OTGCON         (*(volatile uint8_t *)(0x70 + _USBOTG_ADDR))
  #define U_OTGCON_CLR     (*(volatile uint8_t *)(0x74 + _USBOTG_ADDR))
  #define U_OTGCON_SET     (*(volatile uint8_t *)(0x78 + _USBOTG_ADDR))
  #define U_OTGCON_INV     (*(volatile uint8_t *)(0x7C + _USBOTG_ADDR))
  #define U_PWRC           (*(volatile uint8_t *)(0x80 + _USBOTG_ADDR))
  #define U_PWRC_CLR       (*(volatile uint8_t *)(0x84 + _USBOTG_ADDR))
  #define U_PWRC_SET       (*(volatile uint8_t *)(0x88 + _USBOTG_ADDR))
  #define U_PWRC_INV       (*(volatile uint8_t *)(0x8C + _USBOTG_ADDR))
  #define U_IR             (*(volatile uint8_t *)(0x200 + _USBOTG_ADDR))
  #define U_IR_CLR         (*(volatile uint8_t *)(0x204 + _USBOTG_ADDR))
  #define U_IE             (*(volatile uint8_t *)(0x210 + _USBOTG_ADDR))
  #define U_IE_CLR         (*(volatile uint8_t *)(0x214 + _USBOTG_ADDR))
  #define U_IE_SET         (*(volatile uint8_t *)(0x218 + _USBOTG_ADDR))
  #define U_IE_INV         (*(volatile uint8_t *)(0x21C + _USBOTG_ADDR))
  #define U_EIR            (*(volatile uint8_t *)(0x220 + _USBOTG_ADDR))
  #define U_EIR_CLR        (*(volatile uint8_t *)(0x224 + _USBOTG_ADDR))
  #define U_EIE            (*(volatile uint8_t *)(0x230 + _USBOTG_ADDR))
  #define U_EIE_CLR        (*(volatile uint8_t *)(0x234 + _USBOTG_ADDR))
  #define U_EIE_SET        (*(volatile uint8_t *)(0x238 + _USBOTG_ADDR))
  #define U_EIE_INV        (*(volatile uint8_t *)(0x23C + _USBOTG_ADDR))
  #define U_STAT           (*(volatile uint8_t *)(0x240 + _USBOTG_ADDR))
  #define U_STAT_CLR       (*(volatile uint8_t *)(0x244 + _USBOTG_ADDR))
  #define U_STAT_SET       (*(volatile uint8_t *)(0x248 + _USBOTG_ADDR))
  #define U_STAT_INV       (*(volatile uint8_t *)(0x24C + _USBOTG_ADDR))
  #define U_CON            (*(volatile uint8_t *)(0x250 + _USBOTG_ADDR))
  #define U_CON_CLR        (*(volatile uint8_t *)(0x254 + _USBOTG_ADDR))
  #define U_CON_SET        (*(volatile uint8_t *)(0x258 + _USBOTG_ADDR))
  #define U_CON_INV        (*(volatile uint8_t *)(0x25C + _USBOTG_ADDR))
  #define U_ADDR           (*(volatile uint8_t *)(0x260 + _USBOTG_ADDR))
  #define U_ADDR_CLR       (*(volatile uint8_t *)(0x264 + _USBOTG_ADDR))
  #define U_ADDR_SET       (*(volatile uint8_t *)(0x268 + _USBOTG_ADDR))
  #define U_ADDR_INV       (*(volatile uint8_t *)(0x26C + _USBOTG_ADDR))
  #define U_BDTP1          (*(volatile uint8_t *)(0x270 + _USBOTG_ADDR))
  #define U_BDTP1_CLR      (*(volatile uint8_t *)(0x274 + _USBOTG_ADDR))
  #define U_BDTP1_SET      (*(volatile uint8_t *)(0x278 + _USBOTG_ADDR))
  #define U_BDTP1_INV      (*(volatile uint8_t *)(0x27C + _USBOTG_ADDR))
  #define U_FRML           (*(volatile uint8_t *)(0x280 + _USBOTG_ADDR))
  #define U_FRMLCLR        (*(volatile uint8_t *)(0x284 + _USBOTG_ADDR))
  #define U_FRMLSET        (*(volatile uint8_t *)(0x288 + _USBOTG_ADDR))
  #define U_FRMLINV        (*(volatile uint8_t *)(0x28C + _USBOTG_ADDR))
  #define U_FRMH           (*(volatile uint8_t *)(0x290 + _USBOTG_ADDR))
  #define U_FRMH_CLR       (*(volatile uint8_t *)(0x294 + _USBOTG_ADDR))
  #define U_FRMH_SET       (*(volatile uint8_t *)(0x298 + _USBOTG_ADDR))
  #define U_FRMH_INV       (*(volatile uint8_t *)(0x29C + _USBOTG_ADDR))
  #define U_TOK            (*(volatile uint8_t *)(0x2A0 + _USBOTG_ADDR))
  #define U_TOK_CLR        (*(volatile uint8_t *)(0x2A4 + _USBOTG_ADDR))
  #define U_TOK_SET        (*(volatile uint8_t *)(0x2A8 + _USBOTG_ADDR))
  #define U_TOK_INV        (*(volatile uint8_t *)(0x2AC + _USBOTG_ADDR))
  #define U_SOF            (*(volatile uint8_t *)(0x2B0 + _USBOTG_ADDR))
  #define U_SOF_CLR        (*(volatile uint8_t *)(0x2B4 + _USBOTG_ADDR))
  #define U_SOF_SET        (*(volatile uint8_t *)(0x2B8 + _USBOTG_ADDR))
  #define U_SOF_INV        (*(volatile uint8_t *)(0x2BC + _USBOTG_ADDR))
  #define U_BDTP2          (*(volatile uint8_t *)(0x2C0 + _USBOTG_ADDR))
  #define U_BDTP2_CLR      (*(volatile uint8_t *)(0x2C4 + _USBOTG_ADDR))
  #define U_BDTP2_SET      (*(volatile uint8_t *)(0x2C8 + _USBOTG_ADDR))
  #define U_BDTP2_INV      (*(volatile uint8_t *)(0x2CC + _USBOTG_ADDR))
  #define U_BDTP3          (*(volatile uint8_t *)(0x2D0 + _USBOTG_ADDR))
  #define U_BDTP3_CLR      (*(volatile uint8_t *)(0x2D4 + _USBOTG_ADDR))
  #define U_BDTP3_SET      (*(volatile uint8_t *)(0x2D8 + _USBOTG_ADDR))
  #define U_BDTP3_INV      (*(volatile uint8_t *)(0x2DC + _USBOTG_ADDR))
  #define U_CNFG1          (*(volatile uint8_t *)(0x2E0 + _USBOTG_ADDR))
  #define U_CNFG1_CLR      (*(volatile uint8_t *)(0x2E4 + _USBOTG_ADDR))
  #define U_CNFG1_SET      (*(volatile uint8_t *)(0x2E8 + _USBOTG_ADDR))
  #define U_CNFG1_INV      (*(volatile uint8_t *)(0x2EC + _USBOTG_ADDR))

  /* x=1: EP0 ... x=15: EP15 */
  #define U_EP(x)          (*(volatile uint8_t *)(0x0 + _USBOTG_EP_ADDR(x)))
  #define U_EP0_CLR(x)     (*(volatile uint8_t *)(0x4 + _USBOTG_EP_ADDR(x)))
  #define U_EP0_SET(x)     (*(volatile uint8_t *)(0x8 + _USBOTG_EP_ADDR(x)))
  #define U_EP0_INV(x)     (*(volatile uint8_t *)(0xC + _USBOTG_EP_ADDR(x)))
#else
  #define U_OTGIR          (*(volatile uint8_t *)0xBF885040)
  #define U_OTGIR_CLR      (*(volatile uint8_t *)0xBF885044)
  #define U_OTGIE          (*(volatile uint8_t *)0xBF885050)
  #define U_OTGIE_CLR      (*(volatile uint8_t *)0xBF885054)
  #define U_OTGIE_SET      (*(volatile uint8_t *)0xBF885058)
  #define U_OTGIE_INV      (*(volatile uint8_t *)0xBF88505C)
  #define U_OTGSTAT        (*(volatile uint8_t *)0xBF885060)
  #define U_OTGCON         (*(volatile uint8_t *)0xBF885070)
  #define U_OTGCON_CLR     (*(volatile uint8_t *)0xBF885074)
  #define U_OTGCON_SET     (*(volatile uint8_t *)0xBF885078)
  #define U_OTGCON_INV     (*(volatile uint8_t *)0xBF88507C)
  #define U_PWRC           (*(volatile uint8_t *)0xBF885080)
  #define U_PWRC_CLR       (*(volatile uint8_t *)0xBF885084)
  #define U_PWRC_SET       (*(volatile uint8_t *)0xBF885088)
  #define U_PWRC_INV       (*(volatile uint8_t *)0xBF88508C)
  #define U_IR             (*(volatile uint8_t *)0xBF885200)
  #define U_IR_CLR         (*(volatile uint8_t *)0xBF885204)
  #define U_IE             (*(volatile uint8_t *)0xBF885210)
  #define U_IE_CLR         (*(volatile uint8_t *)0xBF885214)
  #define U_IE_SET         (*(volatile uint8_t *)0xBF885218)
  #define U_IE_INV         (*(volatile uint8_t *)0xBF88521C)
  #define U_EIR            (*(volatile uint8_t *)0xBF885220)
  #define U_EIR_CLR        (*(volatile uint8_t *)0xBF885224)
  #define U_EIE            (*(volatile uint8_t *)0xBF885230)
  #define U_EIE_CLR        (*(volatile uint8_t *)0xBF885234)
  #define U_EIE_SET        (*(volatile uint8_t *)0xBF885238)
  #define U_EIE_INV        (*(volatile uint8_t *)0xBF88523C)
  #define U_STAT           (*(volatile uint8_t *)0xBF885240)
  #define U_STAT_CLR       (*(volatile uint8_t *)0xBF885244)
  #define U_STAT_SET       (*(volatile uint8_t *)0xBF885248)
  #define U_STAT_INV       (*(volatile uint8_t *)0xBF88524C)
  #define U_CON            (*(volatile uint8_t *)0xBF885250)
  #define U_CON_CLR        (*(volatile uint8_t *)0xBF885254)
  #define U_CON_SET        (*(volatile uint8_t *)0xBF885258)
  #define U_CON_INV        (*(volatile uint8_t *)0xBF88525C)
  #define U_ADDR           (*(volatile uint8_t *)0xBF885260)
  #define U_ADDR_CLR       (*(volatile uint8_t *)0xBF885264)
  #define U_ADDR_SET       (*(volatile uint8_t *)0xBF885268)
  #define U_ADDR_INV       (*(volatile uint8_t *)0xBF88526C)
  #define U_BDTP1          (*(volatile uint8_t *)0xBF885270)
  #define U_BDTP1_CLR      (*(volatile uint8_t *)0xBF885274)
  #define U_BDTP1_SET      (*(volatile uint8_t *)0xBF885278)
  #define U_BDTP1_INV      (*(volatile uint8_t *)0xBF88527C)
  #define U_FRML           (*(volatile uint8_t *)0xBF885280)
  #define U_FRMLCLR        (*(volatile uint8_t *)0xBF885284)
  #define U_FRMLSET        (*(volatile uint8_t *)0xBF885288)
  #define U_FRMLINV        (*(volatile uint8_t *)0xBF88528C)
  #define U_FRMH           (*(volatile uint8_t *)0xBF885290)
  #define U_FRMH_CLR       (*(volatile uint8_t *)0xBF885294)
  #define U_FRMH_SET       (*(volatile uint8_t *)0xBF885298)
  #define U_FRMH_INV       (*(volatile uint8_t *)0xBF88529C)
  #define U_TOK            (*(volatile uint8_t *)0xBF8852A0)
  #define U_TOK_CLR        (*(volatile uint8_t *)0xBF8852A4)
  #define U_TOK_SET        (*(volatile uint8_t *)0xBF8852A8)
  #define U_TOK_INV        (*(volatile uint8_t *)0xBF8852AC)
  #define U_SOF            (*(volatile uint8_t *)0xBF8852B0)
  #define U_SOF_CLR        (*(volatile uint8_t *)0xBF8852B4)
  #define U_SOF_SET        (*(volatile uint8_t *)0xBF8852B8)
  #define U_SOF_INV        (*(volatile uint8_t *)0xBF8852BC)
  #define U_BDTP2          (*(volatile uint8_t *)0xBF8852C0)
  #define U_BDTP2_CLR      (*(volatile uint8_t *)0xBF8852C4)
  #define U_BDTP2_SET      (*(volatile uint8_t *)0xBF8852C8)
  #define U_BDTP2_INV      (*(volatile uint8_t *)0xBF8852CC)
  #define U_BDTP3          (*(volatile uint8_t *)0xBF8852D0)
  #define U_BDTP3_CLR      (*(volatile uint8_t *)0xBF8852D4)
  #define U_BDTP3_SET      (*(volatile uint8_t *)0xBF8852D8)
  #define U_BDTP3_INV      (*(volatile uint8_t *)0xBF8852DC)
  #define U_CNFG1          (*(volatile uint8_t *)0xBF8852E0)
  #define U_CNFG1_CLR      (*(volatile uint8_t *)0xBF8852E4)
  #define U_CNFG1_SET      (*(volatile uint8_t *)0xBF8852E8)
  #define U_CNFG1_INV      (*(volatile uint8_t *)0xBF8852EC)

  /* x=1: EP0 ... x=15: EP15 */
  #define U_EP(x)          (*(volatile uint8_t *)(0xBF885300 + (x)*0x10))
  #define U_EP0_CLR(x)     (*(volatile uint8_t *)(0xBF885304 + (x)*0x10))
  #define U_EP0_SET(x)     (*(volatile uint8_t *)(0xBF885308 + (x)*0x10))
  #define U_EP0_INV(x)     (*(volatile uint8_t *)(0xBF88530C + (x)*0x10))
#endif
    #define U_OTGIR_VBUSVDIF               0x00
    #define U_OTGIR_SESENDIF               0x02
    #define U_OTGIR_SESVDIF                0x03
    #define U_OTGIR_ACTVIF                 0x04
    #define U_OTGIR_LSTATEIF               0x05
    #define U_OTGIR_T1MSECIF               0x06
    #define U_OTGIR_IDIF                   0x07
    #define U_OTGIE_VBUSVDIE               0x00
    #define U_OTGIE_SESENDIE               0x02
    #define U_OTGIE_SESVDIE                0x03
    #define U_OTGIE_ACTVIE                 0x04
    #define U_OTGIE_LSTATEIE               0x05
    #define U_OTGIE_T1MSECIE               0x06
    #define U_OTGIE_IDIE                   0x07
    #define U_OTGSTAT_VBUSVD               0x00
    #define U_OTGSTAT_SESEND               0x02
    #define U_OTGSTAT_SESVD                0x03
    #define U_OTGSTAT_LSTATE               0x05
    #define U_OTGSTAT_ID                   0x07
    #define U_OTGCON_VBUSDIS               0x00
    #define U_OTGCON_VBUSCHG               0x01
    #define U_OTGCON_OTGEN                 0x02
    #define U_OTGCON_VBUSON                0x03
    #define U_OTGCON_DMPULDWN              0x04
    #define U_OTGCON_DPPULDWN              0x05
    #define U_OTGCON_DMPULUP               0x06
    #define U_OTGCON_DPPULUP               0x07
    #define U_PWRC_USBPWR                  0x00
    #define U_PWRC_USUSPEND                0x01
    #define U_PWRC_USBBUSY                 0x03
    #define U_PWRC_USLPGRD                 0x04
    #define U_PWRC_UACTPND                 0x07
    #define U_IR_URSTIF_DETACHIF           0x00
    #define U_IR_UERRIF                    0x01
    #define U_IR_SOFIF                     0x02
    #define U_IR_TRNIF                     0x03
    #define U_IR_IDLEIF                    0x04
    #define U_IR_RESUMEIF                  0x05
    #define U_IR_ATTACHIF                  0x06
    #define U_IR_STALLIF                   0x07
    #define U_IR_DETACHIF                  0x00
    #define U_IR_URSTIF                    0x00
    #define U_IE_URSTIE_DETACHIE           0x00
    #define U_IE_UERRIE                    0x01
    #define U_IE_SOFIE                     0x02
    #define U_IE_TRNIE                     0x03
    #define U_IE_IDLEIE                    0x04
    #define U_IE_RESUMEIE                  0x05
    #define U_IE_ATTACHIE                  0x06
    #define U_IE_STALLIE                   0x07
    #define U_IE_DETACHIE                  0x00
    #define U_IE_URSTIE                    0x00
    #define U_EIR_PIDEF                    0x00
    #define U_EIR_CRC5EF_EOFEF             0x01
    #define U_EIR_CRC16EF                  0x02
    #define U_EIR_DFN8EF                   0x03
    #define U_EIR_BTOEF                    0x04
    #define U_EIR_DMAEF                    0x05
    #define U_EIR_BMXEF                    0x06
    #define U_EIR_BTSEF                    0x07
    #define U_EIR_CRC5EF                   0x01
    #define U_EIR_EOFEF                    0x01
    #define U_EIE_PIDEE                    0x00
    #define U_EIE_CRC5EE_EOFEE             0x01
    #define U_EIE_CRC16EE                  0x02
    #define U_EIE_DFN8EE                   0x03
    #define U_EIE_BTOEE                    0x04
    #define U_EIE_DMAEE                    0x05
    #define U_EIE_BMXEE                    0x06
    #define U_EIE_BTSEE                    0x07
    #define U_EIE_CRC5EE                   0x01
    #define U_EIE_EOFEE                    0x01
    #define U_STAT_PPBI                    0x02
    #define U_STAT_DIR                     0x03
    #define U_STAT_ENDPT0                  0x04
    #define U_STAT_ENDPT                   0x04
    #define U_STAT_ENDPT1                  0x05
    #define U_STAT_ENDPT2                  0x06
    #define U_STAT_ENDPT3                  0x07
    #define U_CON_USBEN_SOFEN              0x00
    #define U_CON_PPBRST                   0x01
    #define U_CON_RESUME                   0x02
    #define U_CON_HOSTEN                   0x03
    #define U_CON_USBRST                   0x04
    #define U_CON_PKTDIS_TOKBUSY           0x05
    #define U_CON_SE0                      0x06
    #define U_CON_JSTATE                   0x07
    #define U_CON_USBEN                    0x00
    #define U_CON_SOFEN                    0x00
    #define U_CON_PKTDIS                   0x05
    #define U_CON_TOKBUSY                  0x05
    #define U_ADDR_DEVADDR                 0x00
    #define U_ADDR_LSPDEN                  0x07
    #define U_ADDR_DEVADDR0                0x00
    #define U_ADDR_DEVADDR1                0x01
    #define U_ADDR_DEVADDR2                0x02
    #define U_ADDR_DEVADDR3                0x03
    #define U_ADDR_DEVADDR4                0x04
    #define U_ADDR_DEVADDR5                0x05
    #define U_ADDR_DEVADDR6                0x06
    #define U_BDTP1_BDTPTRL                0x01
    #define U_FRML_FRML                    0x00
    #define U_FRML_FRM0                    0x00
    #define U_FRML_FRM1                    0x01
    #define U_FRML_FRM2                    0x02
    #define U_FRML_FRM3                    0x03
    #define U_FRML_FRM4                    0x04
    #define U_FRML_FRM5                    0x05
    #define U_FRML_FRM6                    0x06
    #define U_FRML_FRM7                    0x07
    #define U_FRMH_FRMH                    0x00
    #define U_FRMH_FRM8                    0x00
    #define U_FRMH_FRM9                    0x01
    #define U_FRMH_FRM10                   0x02
    #define U_TOK_EP                       0x00
    #define U_TOK_PID                      0x04
    #define U_TOK_EP0                      0x00
    #define U_TOK_EP1                      0x01
    #define U_TOK_EP2                      0x02
    #define U_TOK_EP3                      0x03
    #define U_TOK_PID0                     0x04
    #define U_TOK_PID1                     0x05
    #define U_TOK_PID2                     0x06
    #define U_TOK_PID3                     0x07
    #define U_SOF_CNT                      0x00
    #define U_BDTP2_BDTPTRH                0x00
    #define U_BDTP3_BDTPTRU                0x00
    #define U_CNFG1_UASUSPND               0x00
    #define U_CNFG1_USBSIDL                0x04
    #define U_CNFG1_UOEMON                 0x06
    #define U_CNFG1_UTEYE                  0x07

    #define U_EP_EPHSHK                   0x00
    #define U_EP_EPSTALL                  0x01
    #define U_EP_EPTXEN                   0x02
    #define U_EP_EPRXEN                   0x03
    #define U_EP_EPCONDIS                 0x04
    #define U_EP_RETRYDIS                 0x06
    #define U_EP_LSPD                     0x07
#endif /* _JZ_P32MX_USBOTG_H_ */
